Package org.opencv.xphoto

## Class Xphoto

- java.lang.Object
- - org.opencv.xphoto.Xphoto

-     public class Xphoto
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `BM3D_STEP1` |
    `static int` | `BM3D_STEP2` |
    `static int` | `BM3D_STEPALL` |
    `static int` | `HAAR` |
    `static int` | `INPAINT_FSR_BEST` |
    `static int` | `INPAINT_FSR_FAST` |
    `static int` | `INPAINT_SHIFTMAP` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Xphoto()` |

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static void` | `applyChannelGains​(Mat src, Mat dst, float gainB, float gainG, float gainR)` | Implements an efficient fixed-point approximation for applying channel gains, which is the last step of multiple white balance algorithms.
    `static void` | `bm3dDenoising​(Mat src, Mat dst)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dst, float h)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dst, float h, int templateWindowSize)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dst, float h, int templateWindowSize, int searchWindowSize)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dst, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dst, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dst, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dst, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize, int slidingStep)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dst, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize, int slidingStep, float beta)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dst, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize, int slidingStep, float beta, int normType)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dst, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize, int slidingStep, float beta, int normType, int step)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dst, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize, int slidingStep, float beta, int normType, int step, int transformType)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2, float h)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2, float h, int templateWindowSize)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2, float h, int templateWindowSize, int searchWindowSize)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize, int slidingStep)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize, int slidingStep, float beta)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize, int slidingStep, float beta, int normType)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize, int slidingStep, float beta, int normType, int step)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static void` | `bm3dDenoising​(Mat src, Mat dstStep1, Mat dstStep2, float h, int templateWindowSize, int searchWindowSize, int blockMatchingStep1, int blockMatchingStep2, int groupSize, int slidingStep, float beta, int normType, int step, int transformType)` | Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations.
    `static GrayworldWB` | `createGrayworldWB()` | Creates an instance of GrayworldWB
    `static LearningBasedWB` | `createLearningBasedWB()` | Creates an instance of LearningBasedWB
    `static LearningBasedWB` | `createLearningBasedWB​(java.lang.String path_to_model)` | Creates an instance of LearningBasedWB
    `static SimpleWB` | `createSimpleWB()` | Creates an instance of SimpleWB
    `static TonemapDurand` | `createTonemapDurand()` | Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those.
    `static TonemapDurand` | `createTonemapDurand​(float gamma)` | Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those.
    `static TonemapDurand` | `createTonemapDurand​(float gamma, float contrast)` | Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those.
    `static TonemapDurand` | `createTonemapDurand​(float gamma, float contrast, float saturation)` | Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those.
    `static TonemapDurand` | `createTonemapDurand​(float gamma, float contrast, float saturation, float sigma_color)` | Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those.
    `static TonemapDurand` | `createTonemapDurand​(float gamma, float contrast, float saturation, float sigma_color, float sigma_space)` | Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those.
    `static void` | `dctDenoising​(Mat src, Mat dst, double sigma)` | The function implements simple dct-based denoising <http://www.ipol.im/pub/art/2011/ys-dct/>.
    `static void` | `dctDenoising​(Mat src, Mat dst, double sigma, int psize)` | The function implements simple dct-based denoising <http://www.ipol.im/pub/art/2011/ys-dct/>.
    `static void` | `inpaint​(Mat src, Mat mask, Mat dst, int algorithmType)` | The function implements different single-image inpainting algorithms.
    `static void` | `oilPainting​(Mat src, Mat dst, int size, int dynRatio)` | oilPainting See the book CITE: Holzmann1988 for details.
    `static void` | `oilPainting​(Mat src, Mat dst, int size, int dynRatio, int code)` | oilPainting See the book CITE: Holzmann1988 for details.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### INPAINT_SHIFTMAP

          public static final int INPAINT_SHIFTMAP

      See Also:
        Constant Field Values

    - #### INPAINT_FSR_BEST

          public static final int INPAINT_FSR_BEST

      See Also:
        Constant Field Values

    - #### INPAINT_FSR_FAST

          public static final int INPAINT_FSR_FAST

      See Also:
        Constant Field Values

    - #### BM3D_STEPALL

          public static final int BM3D_STEPALL

      See Also:
        Constant Field Values

    - #### BM3D_STEP1

          public static final int BM3D_STEP1

      See Also:
        Constant Field Values

    - #### BM3D_STEP2

          public static final int BM3D_STEP2

      See Also:
        Constant Field Values

    - #### HAAR

          public static final int HAAR

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Xphoto

          public Xphoto()

  - ### Method Detail

    - #### createGrayworldWB

          public static GrayworldWB createGrayworldWB()

      Creates an instance of GrayworldWB
      Returns:
        automatically generated

    - #### createLearningBasedWB

          public static LearningBasedWB createLearningBasedWB​(java.lang.String path_to_model)

      Creates an instance of LearningBasedWB
      Parameters:
        `path_to_model` - Path to a .yml file with the model. If not specified, the default model is used
      Returns:
        automatically generated

    - #### createLearningBasedWB

          public static LearningBasedWB createLearningBasedWB()

      Creates an instance of LearningBasedWB
      Returns:
        automatically generated

    - #### createSimpleWB

          public static SimpleWB createSimpleWB()

      Creates an instance of SimpleWB
      Returns:
        automatically generated

    - #### createTonemapDurand

          public static TonemapDurand createTonemapDurand​(float gamma,
                                                          float contrast,
                                                          float saturation,
                                                          float sigma_color,
                                                          float sigma_space)

      Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those. Use them at your own risk.
      Parameters:
        `gamma` - gamma value for gamma correction. See createTonemap
        `contrast` - resulting contrast on logarithmic scale, i. e. log(max / min), where max and min are maximum and minimum luminance values of the resulting image.
        `saturation` - saturation enhancement value. See createTonemapDrago
        `sigma_color` - bilateral filter sigma in color space
        `sigma_space` - bilateral filter sigma in coordinate space
      Returns:
        automatically generated

    - #### createTonemapDurand

          public static TonemapDurand createTonemapDurand​(float gamma,
                                                          float contrast,
                                                          float saturation,
                                                          float sigma_color)

      Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those. Use them at your own risk.
      Parameters:
        `gamma` - gamma value for gamma correction. See createTonemap
        `contrast` - resulting contrast on logarithmic scale, i. e. log(max / min), where max and min are maximum and minimum luminance values of the resulting image.
        `saturation` - saturation enhancement value. See createTonemapDrago
        `sigma_color` - bilateral filter sigma in color space
      Returns:
        automatically generated

    - #### createTonemapDurand

          public static TonemapDurand createTonemapDurand​(float gamma,
                                                          float contrast,
                                                          float saturation)

      Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those. Use them at your own risk.
      Parameters:
        `gamma` - gamma value for gamma correction. See createTonemap
        `contrast` - resulting contrast on logarithmic scale, i. e. log(max / min), where max and min are maximum and minimum luminance values of the resulting image.
        `saturation` - saturation enhancement value. See createTonemapDrago
      Returns:
        automatically generated

    - #### createTonemapDurand

          public static TonemapDurand createTonemapDurand​(float gamma,
                                                          float contrast)

      Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those. Use them at your own risk.
      Parameters:
        `gamma` - gamma value for gamma correction. See createTonemap
        `contrast` - resulting contrast on logarithmic scale, i. e. log(max / min), where max and min are maximum and minimum luminance values of the resulting image.
      Returns:
        automatically generated

    - #### createTonemapDurand

          public static TonemapDurand createTonemapDurand​(float gamma)

      Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those. Use them at your own risk.
      Parameters:
        `gamma` - gamma value for gamma correction. See createTonemap are maximum and minimum luminance values of the resulting image.
      Returns:
        automatically generated

    - #### createTonemapDurand

          public static TonemapDurand createTonemapDurand()

      Creates TonemapDurand object You need to set the OPENCV_ENABLE_NONFREE option in cmake to use those. Use them at your own risk. are maximum and minimum luminance values of the resulting image.
      Returns:
        automatically generated

    - #### applyChannelGains

          public static void applyChannelGains​(Mat src,
                                               Mat dst,
                                               float gainB,
                                               float gainG,
                                               float gainR)

      Implements an efficient fixed-point approximation for applying channel gains, which is the last step of multiple white balance algorithms.
      Parameters:
        `src` - Input three-channel image in the BGR color space (either CV_8UC3 or CV_16UC3)
        `dst` - Output image of the same size and type as src.
        `gainB` - gain for the B channel
        `gainG` - gain for the G channel
        `gainR` - gain for the R channel

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize,
                                           int slidingStep,
                                           float beta,
                                           int normType,
                                           int step,
                                           int transformType)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering.
        `slidingStep` - Sliding step to process every next reference block.
        `beta` - Kaiser window parameter that affects the sidelobe attenuation of the transform of the window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero.
        `normType` - Norm used to calculate distance between blocks. L2 is slower than L1 but yields more accurate results.
        `step` - Step of BM3D to be executed. Allowed are only BM3D_STEP1 and BM3D_STEPALL. BM3D_STEP2 is not allowed as it requires basic estimate to be present.
        `transformType` - Type of the orthogonal transform used in collaborative filtering step. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize,
                                           int slidingStep,
                                           float beta,
                                           int normType,
                                           int step)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering.
        `slidingStep` - Sliding step to process every next reference block.
        `beta` - Kaiser window parameter that affects the sidelobe attenuation of the transform of the window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero.
        `normType` - Norm used to calculate distance between blocks. L2 is slower than L1 but yields more accurate results.
        `step` - Step of BM3D to be executed. Allowed are only BM3D_STEP1 and BM3D_STEPALL. BM3D_STEP2 is not allowed as it requires basic estimate to be present. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize,
                                           int slidingStep,
                                           float beta,
                                           int normType)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering.
        `slidingStep` - Sliding step to process every next reference block.
        `beta` - Kaiser window parameter that affects the sidelobe attenuation of the transform of the window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero.
        `normType` - Norm used to calculate distance between blocks. L2 is slower than L1 but yields more accurate results. BM3D_STEP2 is not allowed as it requires basic estimate to be present. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize,
                                           int slidingStep,
                                           float beta)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering.
        `slidingStep` - Sliding step to process every next reference block.
        `beta` - Kaiser window parameter that affects the sidelobe attenuation of the transform of the window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. BM3D_STEP2 is not allowed as it requires basic estimate to be present. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize,
                                           int slidingStep)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering.
        `slidingStep` - Sliding step to process every next reference block. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. BM3D_STEP2 is not allowed as it requires basic estimate to be present. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. BM3D_STEP2 is not allowed as it requires basic estimate to be present. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. BM3D_STEP2 is not allowed as it requires basic estimate to be present. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. BM3D_STEP2 is not allowed as it requires basic estimate to be present. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. BM3D_STEP2 is not allowed as it requires basic estimate to be present. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst,
                                           float h,
                                           int templateWindowSize)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. BM3D_STEP2 is not allowed as it requires basic estimate to be present. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst,
                                           float h)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise. Should be power of 2. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. BM3D_STEP2 is not allowed as it requires basic estimate to be present. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dst)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dst` - Output image with the same size and type as src. removes image details, smaller h value preserves details but also preserves some noise. Should be power of 2. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. BM3D_STEP2 is not allowed as it requires basic estimate to be present. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize,
                                           int slidingStep,
                                           float beta,
                                           int normType,
                                           int step,
                                           int transformType)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering.
        `slidingStep` - Sliding step to process every next reference block.
        `beta` - Kaiser window parameter that affects the sidelobe attenuation of the transform of the window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero.
        `normType` - Norm used to calculate distance between blocks. L2 is slower than L1 but yields more accurate results.
        `step` - Step of BM3D to be executed. Possible variants are: step 1, step 2, both steps.
        `transformType` - Type of the orthogonal transform used in collaborative filtering step. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize,
                                           int slidingStep,
                                           float beta,
                                           int normType,
                                           int step)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering.
        `slidingStep` - Sliding step to process every next reference block.
        `beta` - Kaiser window parameter that affects the sidelobe attenuation of the transform of the window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero.
        `normType` - Norm used to calculate distance between blocks. L2 is slower than L1 but yields more accurate results.
        `step` - Step of BM3D to be executed. Possible variants are: step 1, step 2, both steps. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize,
                                           int slidingStep,
                                           float beta,
                                           int normType)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering.
        `slidingStep` - Sliding step to process every next reference block.
        `beta` - Kaiser window parameter that affects the sidelobe attenuation of the transform of the window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero.
        `normType` - Norm used to calculate distance between blocks. L2 is slower than L1 but yields more accurate results. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize,
                                           int slidingStep,
                                           float beta)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering.
        `slidingStep` - Sliding step to process every next reference block.
        `beta` - Kaiser window parameter that affects the sidelobe attenuation of the transform of the window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize,
                                           int slidingStep)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering.
        `slidingStep` - Sliding step to process every next reference block. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2,
                                           int groupSize)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `groupSize` - Maximum size of the 3D group for collaborative filtering. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1,
                                           int blockMatchingStep2)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance.
        `blockMatchingStep2` - Block matching threshold for the second step of BM3D (Wiener filtering), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize,
                                           int blockMatchingStep1)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize.
        `blockMatchingStep1` - Block matching threshold for the first step of BM3D (hard thresholding), i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2,
                                           float h,
                                           int templateWindowSize,
                                           int searchWindowSize)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2.
        `searchWindowSize` - Size in pixels of the window that is used to perform block-matching. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2,
                                           float h,
                                           int templateWindowSize)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise.
        `templateWindowSize` - Size in pixels of the template patch that is used for block-matching. Should be power of 2. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2,
                                           float h)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src.
        `h` - Parameter regulating filter strength. Big h value perfectly removes noise but also removes image details, smaller h value preserves details but also preserves some noise. Should be power of 2. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### bm3dDenoising

          public static void bm3dDenoising​(Mat src,
                                           Mat dstStep1,
                                           Mat dstStep2)

      Performs image denoising using the Block-Matching and 3D-filtering algorithm <http://www.cs.tut.fi/~foi/GCF-BM3D/BM3D_TIP_2007.pdf> with several computational optimizations. Noise expected to be a gaussian white noise.
      Parameters:
        `src` - Input 8-bit or 16-bit 1-channel image.
        `dstStep1` - Output image of the first step of BM3D with the same size and type as src.
        `dstStep2` - Output image of the second step of BM3D with the same size and type as src. removes image details, smaller h value preserves details but also preserves some noise. Should be power of 2. Affect performance linearly: greater searchWindowsSize - greater denoising time. Must be larger than templateWindowSize. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. i.e. maximum distance for which two blocks are considered similar. Value expressed in euclidean distance. window. Kaiser window is used in order to reduce border effects. To prevent usage of the window, set beta to zero. but yields more accurate results. Currently only Haar transform is supported. This function expected to be applied to grayscale images. Advanced usage of this function can be manual denoising of colored image in different colorspaces. SEE: fastNlMeansDenoising

    - #### dctDenoising

          public static void dctDenoising​(Mat src,
                                          Mat dst,
                                          double sigma,
                                          int psize)

      The function implements simple dct-based denoising <http://www.ipol.im/pub/art/2011/ys-dct/>.
      Parameters:
        `src` - source image
        `dst` - destination image
        `sigma` - expected noise standard deviation
        `psize` - size of block side where dct is computed SEE: fastNlMeansDenoising

    - #### dctDenoising

          public static void dctDenoising​(Mat src,
                                          Mat dst,
                                          double sigma)

      The function implements simple dct-based denoising <http://www.ipol.im/pub/art/2011/ys-dct/>.
      Parameters:
        `src` - source image
        `dst` - destination image
        `sigma` - expected noise standard deviation SEE: fastNlMeansDenoising

    - #### inpaint

          public static void inpaint​(Mat src,
                                     Mat mask,
                                     Mat dst,
                                     int algorithmType)

      The function implements different single-image inpainting algorithms. See the original papers CITE: He2012 (Shiftmap) or CITE: GenserPCS2018 and CITE: SeilerTIP2015 (FSR) for details.
      Parameters:
        `src` - source image
        - #INPAINT_SHIFTMAP: it could be of any type and any number of channels from 1 to 4. In case of 3- and 4-channels images the function expect them in CIELab colorspace or similar one, where first color component shows intensity, while second and third shows colors. Nonetheless you can try any colorspaces.
        - #INPAINT_FSR_BEST or #INPAINT_FSR_FAST: 1-channel grayscale or 3-channel BGR image.
        `mask` - mask (#CV_8UC1), where non-zero pixels indicate valid image area, while zero pixels indicate area to be inpainted
        `dst` - destination image
        `algorithmType` - see xphoto::InpaintTypes

  - #### oilPainting

        public static void oilPainting​(Mat src,
                                       Mat dst,
                                       int size,
                                       int dynRatio,
                                       int code)

    oilPainting See the book CITE: Holzmann1988 for details.
    Parameters:
      `src` - Input three-channel or one channel image (either CV_8UC3 or CV_8UC1)
      `dst` - Output image of the same size and type as src.
      `size` - neighbouring size is 2-size+1
      `dynRatio` - image is divided by dynRatio before histogram processing
      `code` - automatically generated

  - #### oilPainting

        public static void oilPainting​(Mat src,
                                       Mat dst,
                                       int size,
                                       int dynRatio)

    oilPainting See the book CITE: Holzmann1988 for details.
    Parameters:
      `src` - Input three-channel or one channel image (either CV_8UC3 or CV_8UC1)
      `dst` - Output image of the same size and type as src.
      `size` - neighbouring size is 2-size+1
      `dynRatio` - image is divided by dynRatio before histogram processing